###############################################################################
# UsersToday.pm (Users Today - Sources)                                       #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.7.00                                                 #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2016 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
###############################################################################

$userstodaypmver = 'YaBB 2.7.00 $Revision: 1.45 $';
if ( $action eq 'detailedversion' ) { return 1; }

LoadLanguage('Mods/UsersToday');

sub userstoday {

    my $newdate = time;
    my $toffs = toffs($newdate);
    ( undef, undef, undef, $utday, $utmon, $utyear, $utwday, undef, undef ) =
      gmtime( $newdate + $toffs );

    $utmon_num  = $utmon + 1;
    $utsaveyear = ( $utyear % 100 );
    $utyear     = 1900 + $utyear;
    if ( $utmon_num < 10 )  { $utmon_num  = "0$utmon_num" }
    if ( $utday < 10 )      { $utday      = "0$utday" }
    if ( $utsaveyear < 10 ) { $utsaveyear = "0$utsaveyear" }

## create files to avoid the initial "dreaded -1" on first load ##
    if ( !-e ("$vardir/usertoday.txt") ) {
        fopen( FILE, ">$vardir/usertoday.txt" );
        print {FILE} "$utmon_num|$utday|$utsaveyear|$utwday\n"
          or croak "$croak{'print'} FILE";
        print {FILE} "$utday\n" or croak "$croak{'print'} FILE";
        fclose(FILE);
    }
    if ( !-e ("$vardir/guesttoday.txt") ) {
        fopen( GUESTFILE, ">$vardir/guesttoday.txt" );
        print {GUESTFILE} "$utday\n" or croak "$croak{'print'} GUESTFILE";
        fclose(GUESTFILE);
    }
    if ( !-e ("$vardir/uttotal.txt") ) {
        fopen( UTTOTAL, ">$vardir/uttotal.txt" );
        fclose(UTTOTAL);
    }
    if ( !-e ("$vardir/utstats.txt") ) {
        fopen( UTSTATS, ">$vardir/utstats.txt" );
        fclose(UTSTATS);
    }
    fopen( FILE, "$vardir/usertoday.txt" );
    @utoday = <FILE>;
    fclose(FILE);
    $usertodaycount  = @utoday;
    $usertoday       = q{};
    $usertodaycount2 = 0;
    for my $aa ( 2 .. ( $usertodaycount - 1 ) ) {
        $utoday[$aa] =~ s/\n//gism;
        $utname = $utoday[$aa];
        if ( $utname ne q{} ) { LoadUser($utname); }
        if ( $utname eq $username ) { $Inserted1 = 'true'; }
        if ( -e "$memberdir/$name.vars" && $utname eq $name ) {
            $Inserted2 = 'true';
        }
        if ( ${ $uid . $utname }{'stealth'} && ( $iamadmin || $iamgmod ) ) {
            $usertoday .= QuickLinks($utname) . q~*, ~;
            $usertodaycount2++;
        }
        elsif ( !${ $uid . $utname }{'stealth'} ) {
            $usertoday .= QuickLinks($utname) . q~, ~;
            $usertodaycount2++;
        }
    }
    $usertodaycount = $usertodaycount2;
    if ( !$iamguest && ( $Inserted1 && $Inserted2 ) ne 'true' ) {
        if ( $Inserted1 ne 'true' ) {
            fopen( FILE, ">>$vardir/usertoday.txt" );
            print {FILE} "$username\n" or croak "$croak{'print'} FILE";
            fclose(FILE);
        }
        elsif ( -e ("$memberdir/$name.vars") && $Inserted2 ne 'true' ) {
            fopen( FILE, ">>$vardir/usertoday.txt" );
            print {FILE} "$name\n" or croak "$croak{'print'} FILE";
            fclose(FILE);
        }
    }
    elsif ( !$iamguest && $Inserted1 eq 'true' && $Inserted2 ne 'true' ) {
        fopen( FILE, ">>$vardir/usertoday.txt" );
        print {FILE} "$username\n" or croak "$croak{'print'} FILE";
        fclose(FILE);
    }
    elsif ( !$iamguest && $Inserted1 ne 'true' && $Inserted2 eq 'true' ) {
        fopen( FILE, ">>$vardir/usertoday.txt" );
        print {FILE} "$name\n" or croak "$croak{'print'} FILE";
        fclose(FILE);
    }
    $usertoday =~ s/, \Z//sm;
    if ( $usertodaycount == 1 ) {
        $userstoday =
          qq~$uttxt{'1'}<b>$usertodaycount</b>$uttxt{'3'}<br />$usertoday~;
    }
    else {
        $userstoday =
          qq~$uttxt{'1a'}<b>$usertodaycount</b>$uttxt{'3a'}<br />$usertoday~;
    }
## Reading the guests today file ##
    fopen( GUESTFILE, "$vardir/guesttoday.txt" );
    @gtoday = <GUESTFILE>;
    fclose(GUESTFILE);
    $guesttodaycount = @gtoday;
    for my $g ( 1 .. ( $guesttodaycount - 1 ) ) {
        $gtoday[$g] =~ s/\n//gism;
        $g_ip = $gtoday[$g];
        if ( $g_ip eq $user_ip ) { $gInserted = 'true'; }
        if ( $view_ips == 1 && ( $iamadmin || $iamgmod ) ) {
            $guesttoday .= qq~$g_ip~;
            if ( $guesttodaycount > 1 ) { $guesttoday .= q~, ~; }
        }
        else { $guesttoday = q~<!--Not listing IP addresses-->~; }
    }
    $guesttodaycount = $guesttodaycount - 1;
    if ( $view_ips == 1 && ( $iamadmin || $iamgmod ) ) {
        if ( $guesttodaycount == 1 ) {
            $guesttrailtext = qq~$uttxt{'2b'}<br />~;
        }
        else { $guesttrailtext = qq~$uttxt{'2c'}<br />~; }
    }
    else {
        if   ( $guesttodaycount == 1 ) { $guesttrailtext = qq~$uttxt{'2'}~; }
        else                           { $guesttrailtext = qq~$uttxt{'2a'}~; }
    }
    if ( $gInserted ne 'true' && $username eq 'Guest' ) {
        fopen( GUESTFILE, ">>$vardir/guesttoday.txt" );
        print {GUESTFILE} "$user_ip\n" or croak "$croak{'print'} GUESTFILE";
        fclose(GUESTFILE);
    }
## Prepare data from usertoday.txt and guesttoday.txt for writing to log file ##
    if ( ( $utoday[1] || $gtoday[0] ) != $utday ) {
        fopen( YFILE, "$vardir/usertoday.txt" );
        @usersyest = <YFILE>;
        fclose(YFILE);
        $usercount = @usersyest;
        $usercount = $usercount - 2;
        fopen( YGUESTFILE, "$vardir/guesttoday.txt" );
        @guestyest = <YGUESTFILE>;
        fclose(YGUESTFILE);
        $guestcount = @guestyest;
        $guestcount = $guestcount - 1;
        ( $yestmon, $yestday, $yestyear, $yestdoy ) =
          split /[|]/xsm, $usersyest[0];
        chomp $yestdoy;
## Add yesterday's user and guest count to log file ##
        my ( $memcount, $latestmember ) = MembershipGet();
        $mempercent = ( $usertodaycount / $memcount ) * 100;
        my $mempercent = sprintf '%.2f', $mempercent;
        fopen( UTTOTAL, ">>$vardir/uttotal.txt" );
        print {UTTOTAL}
"$yestmon|$yestday|$yestyear|$yestdoy|$usercount|$mempercent|$guestcount\n"
          or croak "$croak{'print'} UTTOTAL";
        fclose(UTTOTAL);
## Check stats file to see if it needs updating ##
        fopen( UTSTATS, "$vardir/utstats.txt" );
        @utstats = <UTSTATS>;
        fclose(UTSTATS);
        ( $utmostuser, $utmumo, $utmuday, $utmuyr ) =
          split /[|]/xsm, $utstats[0];
        ( $utmostguest, $utmgmo, $utmgday, $utmgyr ) =
          split /[|]/xsm, $utstats[1];
        ($uttotaluser)  = $utstats[2];
        ($uttotalguest) = $utstats[3];
        ($utlogdays)    = $utstats[4];
        chomp $utmuyr;
        chomp $utmgyr;
        chomp $uttotaluser;
        chomp $uttotalguest;
        chomp $utlogdays;
        fopen( UTSTATS, ">$vardir/utstats.txt" );

        if ( $usercount >= $utmostuser ) {
            $utmostuser = $usercount;
            $utmumo     = $yestmon;
            $utmuday    = $yestday;
            $utmuyr     = $yestyear;
        }
        if ( $guestcount >= $utmostguest ) {
            $utmostguest = $guestcount;
            $utmgmo      = $yestmon;
            $utmgday     = $yestday;
            $utmgyr      = $yestyear;
        }
        $uttotaluser  = $uttotaluser + $usercount;
        $uttotalguest = $uttotalguest + $guestcount;
        $utlogdays    = $utlogdays + 1;
        $utavguser    = ( $uttotaluser / $utlogdays );
        my $utavguser = sprintf '%.2f', $utavguser;
        $utavgguest = ( $uttotalguest / $utlogdays );
        my $utavgguest = sprintf '%.2f', $utavgguest;
        print {UTSTATS} "$utmostuser|$utmumo|$utmuday|$utmuyr\n"
          or croak "$croak{'print'} UTSTATS";
        print {UTSTATS} "$utmostguest|$utmgmo|$utmgday|$utmgyr\n"
          or croak "$croak{'print'} UTSTATS";
        print {UTSTATS} "$uttotaluser\n"  or croak "$croak{'print'} UTSTATS";
        print {UTSTATS} "$uttotalguest\n" or croak "$croak{'print'} UTSTATS";
        print {UTSTATS} "$utlogdays\n"    or croak "$croak{'print'} UTSTATS";
        print {UTSTATS} "$utavguser\n"    or croak "$croak{'print'} UTSTATS";
        print {UTSTATS} "$utavgguest\n"   or croak "$croak{'print'} UTSTATS";
        print {UTSTATS} "$memcount\n"     or croak "$croak{'print'} UTSTATS";
        fclose(UTSTATS);
## Clear usertoday.txt for new day ##
        fopen( FILE, ">$vardir/usertoday.txt" );
        print {FILE} "$utmon_num|$utday|$utsaveyear|$utwday\n"
          or croak "$croak{'print'} FILE";
        print {FILE} "$utday\n" or croak "$croak{'print'} FILE";
## Clear guesttoday.txt for new day ##
        fopen( GUESTFILE, ">$vardir/guesttoday.txt" );
        print {GUESTFILE} "$utday\n" or croak "$croak{'print'} GUESTFILE";
        fclose(GUESTFILE);
    }
    if ( $show_guest_today == 1 ) {
        $onlinetoday = qq~$uttxt{'4'}$uttxt{'4a'}~;
        if ( ( $iamadmin || $iamgmod ) && $guest_ip == 1 && $link_guest == 1 ) {
            if ( $guesttodaycount == 1 ) {
                $gueststoday =
qq~$uttxt{'1'}<a href="$boardurl/AdminIndex.$yyaext?action=userstoday" style="color: red; text-decoration: underline;"><b>$guesttodaycount</b></a>$guesttrailtext$guesttoday<br />~;
            }
            else {
                $gueststoday =
qq~$uttxt{'1a'}<a href="$boardurl/AdminIndex.$yyaext?action=userstoday" style="color: red; text-decoration: underline;"><b>$guesttodaycount</b></a>$guesttrailtext$guesttoday<br />~;
            }
        }
        else {
            if ( $guesttodaycount == 1 ) {
                $gueststoday =
qq~$uttxt{'1'}<b>$guesttodaycount</b>$guesttrailtext$guesttoday<br />~;
            }
            else {
                $gueststoday =
qq~$uttxt{'1a'}<b>$guesttodaycount</b>$guesttrailtext<br />$guesttoday~;
            }
        }
    }
    else {
        $onlinetoday = qq~$uttxt{'4a'}~;
        $gueststoday = q~<!--Not Available -->~;
    }
    if ( $log_only == 1 ) {
        $row_resize = qq~
       <td class="windowbg center">
          <img src="$imagesdir/online.png" alt="" />
       </td>~;
        $userstoday = q~<!--Not Available-->~;
    }
    elsif ( ( $iamguest && $guest_view == 1 ) || $username ne 'Guest' ) {
        if ( $plogopt == 1 ) {
            if (   ( $plogopt2 == 0 && $iamadmin )
                || ( $plogopt2 == 1 && ( $iamadmin || $iamgmod ) )
                || ( $plogopt2 == 2 && !$iamguest )
                || ( $plogopt2 == 3 ) )
            {
                $showplog =
qq~<a class="small" href="$scripturl?action=showlog">$uttxt{'99'}</a>~;
            }
            else { $showplog = q~<!--Not for you to see-->~; }
        }
        else { $showplog = q~<!--Not for you to see-->~; }
        $row_resize = $myrow_resize;
        $my_userstoday = $myuserstoday;
        $my_userstoday =~ s/{yabb onlinetoday}/$onlinetoday/sm;
        $my_userstoday =~ s/{yabb gueststoday}/$gueststoday/sm;
        $my_userstoday =~ s/{yabb myuserstoday}/$userstoday/sm;
        $my_userstoday =~ s/{yabb showplog}/$showplog/sm;
    }
    else {
        $row_resize = q{};
        $userstoday = q~<!--Not Available-->~;
    }
    $boardindex_template =~ s/{yabb row_resize}/$row_resize/gsm;
    $boardindex_template =~ s/{yabb userstoday}/$my_userstoday/gsm;
    return;
}

sub show_utlog {
    if ( $plogopt == 1 ) {
        if (   ( $plogopt2 == 0 && $iamadmin )
            || ( $plogopt2 == 1 && ( $iamadmin || $iamgmod ) )
            || ( $plogopt2 == 2 && !$iamguest )
            || ( $plogopt2 == 3 ) )
        {
            $showplog =
qq~<br /><a class="small" href="$scripturl?action=showlog">$uttxt{'99'}</a>~;
        }
        else { fatal_error( $security_txt{'1'} ); }
    }
    else { fatal_error( $security_txt{'1'} ); }
    LoadLanguage('Mods/UsersToday');
    $yytitle = "$uttxt{'16'}";
    $yymain .= qq~
   <table class="bordercolor" style="margin-left: auto; margin-right: auto;">
      <tr>
         <td class="titlebg center" colspan="6"><b>$uttxt{'16'}</b></td>
      </tr>
      <tr>
         <td width="25%" class="windowbg2"><b>$uttxt{'13'}</b></td>
         <td width="15%" class="windowbg2 center"><b>$uttxt{'14'}&nbsp;$uttxt{'14a'}</b></td>
         <td width="10%" class="windowbg2 center"><b>$uttxt{'15'}</b></td>
         <td width="25%" class="windowbg2"><b>$uttxt{'13'}</b></td>
         <td width="15%" class="windowbg2 center"><b>$uttxt{'14'}&nbsp;$uttxt{'14a'}</b></td>
         <td width="10%" class="windowbg2 center"><b>$uttxt{'15'}</b></td>
      </tr>~;
    if ( -e ("$vardir/uttotal.txt") ) {
        fopen( TOTUSER, "$vardir/uttotal.txt" );
        @totusers = <TOTUSER>;
        fclose(TOTUSER);
        $countlog    = @totusers;
        $column_stop = 0;
        $break_line  = ( $countlog / 2 );
        $check_odd   = int( $countlog / 2 );
        if   ( $break_line eq $check_odd ) { $column_stop = $break_line; }
        else                               { $column_stop = $check_odd + 1; }

        for my $t ( 0 .. ( $column_stop - 1 ) ) {
            chomp $userstat;
            (
                $utmonth, $utday, $utyear, $utdow, $totuser, $mempercent,
                $totguest
            ) = split /[|]/xsm, $totusers[$t];
            (
                $utmonth2, $utday2, $utyear2, $utdow2, $totuser2, $mempercent2,
                $totguest2
            ) = split /[|]/xsm, $totusers[ $t + $column_stop ];
            for my $checkut ( 1 .. 9 ) {
                $checkut2 = "0$checkut";
                if ( $utday eq $checkut2 )  { $utday  = $checkut; }
                if ( $utday2 eq $checkut2 ) { $utday2 = $checkut; }
            }
            datestyle();
            $logdate = $dateformat_log2;
            if ( $utmonth2 ne q{} ) {
                $logdate2 = qq~$days[$utdow2], $dateformat_log3~;
            }
            else { $logdate2 = q~<!--Blank-->~; }
            $mempercent =
qq~<span style="color: red; font-style: italic;">($mempercent)</span>~;
            if ( $mempercent2 ne q{} ) {
                $mempercent2 =
qq~<span style="color: red; font-style: italic;">($mempercent2)</span>~;
            }
            else { $mempercent2 = q~<!--Blank-->~; }
            $yymain .= qq~
          <tr>
             <td class="windowbg2"><span style="font-size: 10px;">$days[$utdow], $logdate</span></td>
             <td class="windowbg2 center"><span style="font-size: 10px;">$totuser&nbsp;$mempercent</span></td>
             <td class="windowbg2 center"><span style="font-size: 10px;">$totguest</span></td>
             <td class="windowbg2"><span style="font-size: 10px;">$logdate2</span></td>
             <td class="windowbg2 center"><span style="font-size: 10px;">$totuser2&nbsp;$mempercent2</span></td>
             <td class="windowbg2 center"><span style="font-size: 10px;">$totguest2</span></td>
          </tr>~;
        }
    }
    $yymain .= q~
     </table>~;
    template();
    exit;
}

## define $dateformat ##
sub datestyle {
    if ( $date_style == 0 ) {
        $dateformat_guest      = qq~, $mon_num/$mday/$year~;
        $dateformat_log        = qq~$utmonth/$utday/20$utyear~;
        $dateformat_log2       = qq~$utmonths[$utmonth-1] $utday, 20$utyear~;
        $dateformat_log3       = qq~$utmonths[$utmonth2-1] $utday2, 20$utyear2~;
        $dateformat_user_stats = qq~$utmumo/$utmuday/20$utmuyr~;
        $dateformat_guest_stats = qq~$utmgmo/$utmgday/20$utmgyr~;
    }
    elsif ( $date_style == 1 ) {
        $iplogyear = $year - 2000;
        if ( $iplogyear < 10 ) { $iplogyear = "0$iplogyear"; }
        $dateformat_guest      = qq~, $mon_num/$mday/$iplogyear~;
        $dateformat_log        = qq~$utmonth/$utday/$utyear~;
        $dateformat_log2       = qq~$utmonths[$utmonth-1] $utday, 20$utyear~;
        $dateformat_log3       = qq~$utmonths[$utmonth2-1] $utday2, 20$utyear2~;
        $dateformat_user_stats = qq~$utmumo/$utmuday/$utmuyr~;
        $dateformat_guest_stats = qq~$utmgmo/$utmgday/$utmgyr~;
    }
    elsif ( $date_style == 2 ) {
        $dateformat_guest      = qq~, $mday.$mon_num.$year~;
        $dateformat_log        = qq~$utday.$utmonth.20$utyear~;
        $dateformat_log2       = qq~$utday $utmonths[$utmonth-1], 20$utyear~;
        $dateformat_log3       = qq~$utday2 $utmonths[$utmonth2-1], 20$utyear2~;
        $dateformat_user_stats = qq~$utmuday.$utmumo.20$utmuyr~;
        $dateformat_guest_stats = qq~$utmgday.$utmgmo.20$utmgyr~;
    }
    elsif ( $date_style == 3 ) {
        $iplogyear = $year - 2000;
        if ( $iplogyear < 10 ) { $iplogyear = "0$iplogyear"; }
        $dateformat_guest      = qq~, $mday.$mon_num.$iplogyear~;
        $dateformat_log        = qq~$utday.$utmonth.$utyear~;
        $dateformat_log2       = qq~$utday $utmonths[$utmonth-1], 20$utyear~;
        $dateformat_log3       = qq~$utday2 $utmonths[$utmonth2-1], 20$utyear2~;
        $dateformat_user_stats = qq~$utmuday.$utmumo.$utmuyr~;
        $dateformat_guest_stats = qq~$utmgday.$utmgmo.$utmgyr~;
    }
    return;
}

1;
